//
//Support for different Gametypes and Mods
//The BattleMod support is only half-baked support simply so he works, don't expect proper balance
//

//Should we be allowed to reward free score and 1ups?
rawset(_G, "MarioScoreGametype", function(player)
	return not G_CoopGametype() //gametyperules & GTR_POINTLIMIT (Chaos benefits from this too you know!)
end)

//Don't let coins award score in score gametypes
addHook("MobjSpawn", function(mobj)
	if MarioScoreGametype() then mobj.fuse = 1 end
end, freeslot("MT_COINAWARD"))

//Footstep support
if not PlayerAnimInfo
	rawset(_G, "PlayerAnimInfo", {})
end
PlayerAnimInfo["mario"] = {
	["runFrames"] = {0, 2},
	["dashFrames"] = {-1},
	["walkFrames"] = {3, 7},
	["waitFrames"] = {-1},
	["milnekickFrames"] = {0, 4},
	["run"] = true,
	["dash"] = false,
	["walk"] = true,
	["idle"] = true,
	["wait"] = false,
	["milnekick"] = true,
	["superRun"] = true,
	["superDash"] = false,
	["superWalk"] = true,
	["superIdle"] = true,
	["superWait"] = false
}

//BattleMod Support
if srb2p then return end
local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(CBW_Battle) or ScriptLoaded then return end
	ScriptLoaded = true
	local B = CBW_Battle
	
	local function GarbagePriorityM(player)
		local mo = player.mo
		if mo.state == S_PLAY_MELEE or mo.state == S_PLAY_MELEE_FINISH
		or mo.state == S_PLAY_MELEE_LANDING
			B.SetPriority(player,0,0,"amy_melee",2,3,"hammer strike")
		elseif mo.state == S_MARIO_CAPESPIN
			B.SetPriority(player,1,0,nil,1,0,"cape")
		elseif player.mariogroundpound and not P_IsObjectOnGround(mo)
			B.SetPriority(player,0,0,"fang_tailbounce",2,3,"ground pound")
		end
	end
	
	//Stats
	B.SkinVars["mario"] = {
		func_priority_ext = GarbagePriorityM,
	}
end)